'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  var t = babel.types;

  function isBqlReference(node) {
    // TODO: do this better
    return t.isIdentifier(node, { name: 'bql' });
  }
  return {
    visitor: {
      TaggedTemplateExpression: function TaggedTemplateExpression(path) {
        if (isBqlReference(path.node.tag)) {
          var tokens = (0, _lexer2.default)(path.node.quasi);
          var ast = (0, _parser2.default)(tokens);
          var transformed = (0, _codeGen2.default)(t, ast);
          path.replaceWith(transformed);
        }
      }
    }
  };
};

var _lexer = require('./lexer');

var _lexer2 = _interopRequireDefault(_lexer);

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var _codeGen = require('./code-gen');

var _codeGen2 = _interopRequireDefault(_codeGen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }